package jrummikub.control.network;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import jrummikub.util.Connection;
import jrummikub.util.Event;
import jrummikub.util.IEvent;
import jrummikub.util.IListener;
import jrummikub.util.IListener1;
import jrummikub.util.LoginData;
import jrummikub.view.IGameListPanel;
import jrummikub.view.IGameListPanel.GameData;
import jrummikub.view.IView;

public class NetworkControl {
	private ConnectionControl connectionControl;
	private IView view;
	private List<Connection> connections = new ArrayList<Connection>();
	private Event stopNetworkEvent = new Event();

	public NetworkControl(final LoginData loginData, final IView view) {
		this.view = view;
		connectionControl = new ConnectionControl(loginData);

		connections.add(connectionControl.getConnectedEvent().add(new IListener() {
			@Override
			public void handle() {
				view.getGameListPanel().setChannelName(loginData.getChannelName());
				view.showGameListPanel(true);

				GameData testData = new GameData(UUID.randomUUID(), "NeoRaider");
				testData.setCurrentPlayerCount(2);
				testData.setMaxPlayerCount(4);
				view.getGameListPanel().addGame(testData);
			}
		}));

		connections.add(connectionControl.getConnectionFailedEvent().add(
				new IListener() {
					@Override
					public void handle() {
						// TODO Auto-generated method stub

					}
				}));

		connections.add(view.getGameListPanel().getJoinEvent()
				.add(new IListener1<IGameListPanel.GameData>() {
					@Override
					public void handle(GameData value) {
						// TODO Auto-generated method stub

					}
				}));

		connections.add(view.getGameListPanel().getOpenNewGameEvent()
				.add(new IListener() {
					@Override
					public void handle() {
						// TODO Auto-generated method stub

					}
				}));

		connections.add(view.getGameListPanel().getCancelEvent()
				.add(new IListener() {
					@Override
					public void handle() {
						abort();
						stopNetworkEvent.emit();
					}
				}));
	}

	public void startNetwork() {
		connectionControl.connect();
	}

	public void abort() {
		for (Connection c : connections) {
			c.remove();
		}
		connectionControl.disconnect();
		view.showGameListPanel(false);
	}

	public IEvent getStopNetworkEvent() {
		return stopNetworkEvent;
	}

}
